%% CHRISTIAN FERNANDEZ LANCHARES
%% DATOS DEL VEHICULO 

m= 2108;  % Nuestro vehiculo posee una masa de 2.108 kg.
p=1.225;  % Suponemos una densidad del aire de 1.225 kg/m^3.
g=9.81;   % La gravedad la consideramos de 9.81 m/s^2.
R=0.95;   % Suponemos un rendimiento de la transmision de 0.95.
alfa=0;   % El vehiculo no va a realizar el ascenso de ninguna pendiente.
Cx=0.24;  % Coeficiente de rodadura del vehiculo es de 0.24.
Vw=0;     % La velocidad del viento la consideramos 0, ya que es un recinto
          % cerrado.
Relec=0.92; % Suponemos un rendimiento del motor electrico de 0.92
Rconv=0.95; % Suponemos un rendimiento del convertidor de 0.95.
Rreg=0.85;  % Suponemos un rendimiento del frenado regenerativo del 0.85. 
%% CALCULO DE LA POTENCIA

N=length(v);
for n=2:N,
fr=0.01*(1+(v(n)/160));       % Suponemos un coeficiente base de rodadura de 
                              % 0.01, ya que se realiza sobre rodillos.
Ff=m*g*fr;                    % Fuerza de resistencia a la rodadura.
Af=1.6+0.00056*(m-765);       % Calculo del area frontal del vehiculo.
Fw=(1/2)*p*Af*Cx*(v(n)+Vw)^2; % Fuerza aerodinamica resistente.
Fg=m*g*sin(alfa);             % Fuerza gravitatoria.
a=v(n)-v(n-1);                % Calculo de la aceleracion.      
Pm=(v/R)*(Ff+Fw+Fg+m*a);      % Calculo de la potencia mecanica.
P=Pm/(Relec*Rconv*Rreg);      % Calculo de la potencia electrica demandada.
end

t=1:N;
plot(t,P) 
xlabel('Tiempo(s)');
ylabel('Potencia demandada(W)');
