%%  CHRISTIAN FERNANDEZ LANCHARES
%% Valores iniciales
N=length(v);
%Partimos de la bateria totalmente cargada
Q=3.35;             %Tenemos una capacidad de bateria de 3,35Ah
Npar=64;            % Numero de elementos conectados en paralelo.
Nser=95;            % Numero de elementos conectados en serie. 
Ftension=4.20/4.10; % Factor de adaptacion para la tension.
Frescap=0.15/0.17;  % Factor de adaptacion para las resistencias y las capacitancias.
I0=zeros(1,N);
I=zeros(1,N);
SOC=zeros(1,N);
Rs=zeros(1,N);
R1=zeros(1,N);
C1=zeros(1,N);
R2=zeros(1,N);
C2=zeros(1,N);
Voc=zeros(1,N);
V1=zeros(1,N);
V2=zeros(1,N);
Vrs=zeros(1,N);
Vbat=zeros(1,N);

%% Calculo de la descarga de una bateria de Ion-Litio.
   

for n=2:N,
  
   if(SOC==0),
       SOC=1;                % Partimos de que la bateria esta completamente cargada.
       
   end
   
    
 
  Vbat(1)=400;               % La tension maxima que posee es de 400 V.
   I0(n)=P(n)/Vbat(n-1);     
   I(n)=I0(n)/Npar;          % Calculo de la Intensidad demandada.
       
   fun=@(x) x.^0;
   
   q(n)=quad(fun,n,n+1);
   
   % Calculo de los valores caracteristicos de la bateria.
   SOC(n)=SOC(n-1)-q(n)*I(n)/(Q*3600); 
   
   Rs(n)=Frescap*(0.1562*exp(-24.37*SOC(n))+ 0.07446)*Nser;
   R1(n)=Frescap*(0.3208*exp(-29.14*SOC(n))+0.04669)*Nser;
   C1(n)=Frescap*(-752.9*exp(-13.51*SOC(n))+703.6)/Nser;
   R2(n)=Frescap*(6.603*exp(-155.2*SOC(n))+0.04984)*Nser;
   C2(n)=Frescap*(-6056*exp(-27.12*SOC(n))+4475.0)/Nser;
   Voc(n)=(-1.031*exp(-35*SOC(n))+3.685+0.2156*SOC(n)-0.1178*SOC(n).^2+0.3201*SOC(n).^3)*Nser;
   
   fun1=@(y) ((I(n)/C1(n))-(V1(n-1)/(R1(n)*C1(n))))*y.^0;
   s(n)=quad(fun1,n,n+1);
   V1(n)=(1/100)*s(n);
   
   fun2=@(z) ((I(n)/C2(n))-(V2(n-1)/(R2(n)*C2(n))))*z.^0;
   t(n)=quad(fun1,n,n+1);
   V2(n)=(1/100)*t(n);
   
   Vrs(n)=Rs(n)*I(n);
   
   % Calculo del voltaje de la bateria.
   Vbat(n)=(Voc(n)-V1(n)-V2(n)-Vrs(n))*Ftension;
 
   
  if(Vbat(n)<=0)
      break;
  end
 
    
end

%% Resultados obtenidos.
t=1:N;
plot(t,Vbat), title('Voltaje de bateria-tiempo')
plot(t,I), title('Intensidad de descarga-tiempo')
plot(c,SOC), title('SOC-tiempo')
